#!/usr/bin/env node

var version	=	1.02
,	changes	=	{
		'1.02':		['added Readme.md']
		'1.01':		['added npm-bin support']
		'1.00':		[	'added changenotes'
					,	'added extension support, not only .js now...'
					,	'support for .js, .jade, .haml, .html, .sass, .scss, .less, .styl'
					,	'trying to use npm-js-syntax'
					]
	,	'beta':		['added algorithm to find all files in subdirectories']
	,	'alpha':	['first "stable" version']
	}
,	sys			= require('sys')
,	argv		= require('optimist').argv
,	fs			= require('fs')
,	check		= argv._
,	args		= (argv.p || argv.prozess || check.shift()).split(' ')
,	util		= require('util')
,   spawn		= require('child_process').spawn
,   lilNode		= {
		running: true,
		process: null
	}
,	extensions	= {
		js:		'JavaScript'
	,	styl:	'Stylus-template'
	,	less:	'LESS-template'
	,	jade:	'Jade-template'
	,	haml:	'HAML-template'
	,	html:	'static HTML-File'
	,	sass:	'SASS 3 CSS-template'
	,	scss:	'SASS 3 CSS-template'
	}
,	starting = false

function makeSpawn(reason) {
	console.log('------------------------------------')
	if(starting) return console.log('Already starting...\n------------------------------------')
	starting = true
	if(reason)
		console.log(reason)
	else
		console.log('trying to start process')
	
	var start = function() {
		lilNode.running = true
		lilNode.process	= spawn('node', args)
		console.log('process ' + args + ' started')

		lilNode.process.stdout.on('data', function (data) {
		  util.print('stdout: ' + data)
		})

		lilNode.process.stderr.on('data', function (data) {
		  util.print('stderr: ' + data)
		})
		
		lilNode.process.on('exit', function (code) {
			console.log('process was terminated with code ' + code)
			running = false
			lilNode.process = null
		})
	}

	
	if(lilNode.running && lilNode.process) {
		console.log('need to kill the process first')
		lilNode.process.kill()
		lilNode.process.on('exit', start)
	} else
		start()
	starting = false
	console.log('------------------------------------')
}

makeSpawn()

// syncronous file-finder
if(!check.length) {
	var check = (function find(dir) {
		var stat = fs.lstatSync(dir)
		if(stat.isSymbolicLink())
			return [] // dont like symbolic links
		if(stat.isDirectory()) {
			var result = [dir] // add this directory, now check subdirectory
			var map = fs.readdirSync(dir).map(function(file) {
				return find(dir + '/' + file) // try everything
			})
			return Array.prototype.concat.apply(result, map)
		}
		if(require('path').extname(dir).substr(1) in extensions)
			return [dir]	// add this file
		return []			// but not this (wrong extension
	})(__dirname)
}
// run watchFile for every file
check.forEach(function(file) {
	fs.watchFile(file, function (curr, prev) {
		if(curr.mtime - prev.mtime < 1)
			return
		makeSpawn('filechange in ' + file)
	})
})

console.log('runner started for \'%s\'', args.join(' '))
console.log('watching %d files!', check.length)

